'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = combineReducers;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _types = require('./types');

function combineReducers(reducers) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _ref$idToProps = _ref.idToProps;
  var idToProps = _ref$idToProps === undefined ? {} : _ref$idToProps;
  var alsoAdd = _ref.alsoAdd;

  var combinedReducer = {};
  var alsoResponder = undefined;

  function getInitialState() {
    return Object.keys(reducers).reduce(function (state, reducerID) {
      var reducer = reducers[reducerID];
      if (reducer[_types.GET_INITIAL_STATE]) {
        state[reducerID] = reducer[_types.GET_INITIAL_STATE](idToProps[reducerID]);
      }
      return state;
    }, {});
  }

  var actionSetHandlers = Object.keys(reducers).reduce(function (actionSetHandlers, reducerID) {
    var reducer = reducers[reducerID];
    Object.keys(reducer).reduce(function (actionSetHandlers, property) {
      if (property === _types.GET_INITIAL_STATE || !!actionSetHandlers[property]) {
        return actionSetHandlers;
      }

      actionSetHandlers[property] = function (initialState, _ref2) {
        var actionID = _ref2.actionID;
        var forwardTo = _ref2.forwardTo;

        var newState = Object.keys(reducers).reduce(function (state, reducerID) {
          state[reducerID] = forwardTo({
            responder: reducers[reducerID],
            initialState: initialState[reducerID],
            props: idToProps[reducerID]
          });
          return state;
        }, {});

        if (alsoResponder) {
          newState = forwardTo({
            responder: alsoResponder,
            initialState: newState,
            props: {
              idToProps: idToProps,
              combinedReducer: combinedReducer
            }
          });
        }

        return newState;
      };

      return actionSetHandlers;
    }, actionSetHandlers);

    return actionSetHandlers;
  }, {});

  Object.assign(combinedReducer, _defineProperty({}, _types.GET_INITIAL_STATE, getInitialState), actionSetHandlers);

  if (alsoAdd) {
    alsoResponder = alsoAdd(combinedReducer);
  }

  return combinedReducer;
}

module.exports = exports['default'];