'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _callAction = require('./callAction');

var _callAction2 = _interopRequireDefault(_callAction);

var _notFoundValue = require('./notFoundValue');

var _notFoundValue2 = _interopRequireDefault(_notFoundValue);

var _types = require('./types');

exports['default'] = function (_ref) {
  var resources = _ref.resources;
  var states = _ref.states;
  return function (_ref2) {
    var actionSetID = _ref2.actionSetID;
    var actionID = _ref2.actionID;
    var payload = _ref2.payload;

    var changedStates = {};

    Object.keys(resources).forEach(function (resourceID) {
      var _resources$resourceID = resources[resourceID];
      var reducer = _resources$resourceID.reducer;
      var props = _resources$resourceID.props;

      var result = (0, _callAction2['default'])({
        responder: reducer,
        type: _types.ACTION_TYPE,
        initialState: states[resourceID],
        props: props,
        payload: payload,
        notFoundValue: _notFoundValue2['default'],
        actionSetID: actionSetID,
        actionID: actionID
      });

      if (result !== _notFoundValue2['default']) {
        changedStates[resourceID] = result;
      }
    });

    return changedStates;
  };
};

module.exports = exports['default'];