'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _callAction = require('./callAction');

var _callAction2 = _interopRequireDefault(_callAction);

var _types = require('./types');

var _notFoundValue = require('./notFoundValue');

var _notFoundValue2 = _interopRequireDefault(_notFoundValue);

function consensusForReducerResults(allResults) {
  return {
    some: function some() {
      var callback = arguments.length <= 0 || arguments[0] === undefined ? Boolean : arguments[0];

      return allResults.some(callback);
    },

    every: function every() {
      var callback = arguments.length <= 0 || arguments[0] === undefined ? Boolean : arguments[0];

      return allResults.every(callback);
    },

    reduce: function reduce(callback, initialValue) {
      if (allResults.length === 0 && typeof initialValue === 'undefined') {
        // Do not allow TypeError to be thrown.
        return;
      }

      return allResults.reduce(callback, initialValue);
    },

    singleton: function singleton() {
      if (allResults.length === 1) {
        return allResults[0];
      } else {
        throw "`.singleton()` requires that only one reducer responds to this introspection method." + (allResults.length + ' actually responded.');
      }
    },

    toArray: function toArray() {
      return allResults;
    }
  };
}

exports['default'] = function (_ref) {
  var resources = _ref.resources;
  var states = _ref.states;
  return function (actionSetID) {
    return function (introspectionID) {
      return function () {
        var payload = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

        var allResults = Object.keys(resources).reduce(function (allResults, resourceID) {
          var _resources$resourceID = resources[resourceID];
          var reducer = _resources$resourceID.reducer;
          var props = _resources$resourceID.props;

          var currentValue = (0, _callAction2['default'])({
            responder: reducer,
            type: _types.INTROSPECTION_TYPE,
            initialState: states[resourceID],
            props: props,
            actionID: introspectionID,
            actionSetID: actionSetID,
            payload: payload,
            notFoundValue: _notFoundValue2['default']
          });

          if (currentValue !== _notFoundValue2['default']) {
            allResults.push(currentValue);
          }

          return allResults;
        }, []);

        return consensusForReducerResults(allResults);
      };
    };
  };
};

module.exports = exports['default'];